%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% STANOVENIE INTERVALOV %%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% SPOLAHLIVOSTI PRE PREDIKCIU Z%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% ODHADOV PARAMETROV PO MNC %%%%%

tic;
clear all;
   
%% model nahodneho pohybu castic
    % parametre 
% D_x = 0.002;
% D_y = 0.0005;  
% D_z = 0.001;  
% uhol_y = pi/4;              % polarny
% uhol_z = 7*pi/8;            % azimut
% uhol_x = pi/4;            % torny uhol
%% nahodne nastavenie parametrov
Eig_val = sort((1+2.2*rand(1,3)).*0.001,'descend');
Eig_val(3) =  Eig_val(2)*(1-(rand(1)/4));


D_x = Eig_val(1);
D_y = Eig_val(3);
D_z = Eig_val(2);
uhol_y = rand(1)*pi-pi/2;              % polarny
uhol_z = rand(1)*pi-pi/2;              % azimut
uhol_x = rand(1)*pi-pi/2;              % torny uhol

    % parametre
Nmol = 2000000;                              % pocet castic
% vhodne volit vysoky pocet castic s ohladom na difuzny cas(dt,Ncas), cim sa predite nepriaznivym vplyvom
% disktretizacie, pocet molekul vody v jednom objeme, ktoremu dokazeme
% nanutit rovnae kodovanie v 'stochastickom ponimani'(faza,frekvencia)
% dalekoprevysuje moj vypocetny vykon
MolSurad = zeros(3,Nmol);                   % vsetky castice zacinaju z rovnakeho bodu
dt = 0.0005;                                % [s] casovy usek 
Ncas = 25;                                 % pocet casovych usekov
Dkonst_x = sqrt(2*D_x*dt);     % smerodatne odchylky vzdialenosti, za casovy usek
Dkonst_y = sqrt(2*D_y*dt);       
Dkonst_z = sqrt(2*D_z*dt);
xh = 0.05;                                  % ohranicenie[mm]      
yh = 0.05;
zh = 0.05;
Rot_X_ac = [1 0 0; 0 cos(uhol_x) sin(uhol_x); 0 -sin(uhol_x) cos(uhol_x)];
Rot_Y_ac = [cos(uhol_y) 0 -sin(uhol_y);0 1 0 ; sin(uhol_y) 0 cos(uhol_y)];   % uhly pre stocenie vsetkych castic
Rot_Z_ac = [cos(uhol_z) sin(uhol_z) 0; -sin(uhol_z) cos(uhol_z) 0; 0 0 1];   % rotacne matice
% Rot_X_ac = [1 0 0; 0 cos(uhol_x) -sin(uhol_x); 0 sin(uhol_x) cos(uhol_x)];
% Rot_Y_ac = [cos(uhol_y) 0 sin(uhol_y);0 1 0 ; -sin(uhol_y) 0 cos(uhol_y)];   % uhly pre stocenie vsetkych castic
% Rot_Z_ac = [cos(uhol_z) -sin(uhol_z) 0; -sin(uhol_z) cos(uhol_z) 0; 0 0 1];   % rotacne matice

    % odvodene parametre
ADC0 = sqrt(1/2)*( (sqrt((D_x-D_y)^2+(D_y-D_z)^2+(D_z-D_x)^2))/(sqrt(D_x^2+D_y^2+D_z^2)) );
Pvv0 = D_y/D_z;
% EigVal = sort([D_x D_y D_z],'descend');
% Pvv0 = EigVal(3)/EigVal(2);
% 
% if D_z > D_y
%     TORZNY = uhol_z;
% end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
zadane_P = [D_x,ADC0,uhol_z,uhol_y,Pvv0,uhol_x];        %%%%%%%%%%%% "SVATY" GRAL %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp([num2str(zadane_P),'  Zadane parametre su']);        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% simulacia
tic;
for t=1:Ncas
        nah = randn(3,Nmol);
        MolSurad(1,:) = MolSurad(1,:) + Dkonst_x.*nah(1,:);
        MolSurad(2,:) = MolSurad(2,:) + Dkonst_y.*nah(2,:);
        MolSurad(3,:) = MolSurad(3,:) + Dkonst_z.*nah(3,:);

        % korekcia castic za hranicou vymedzeneho priestoru
        Zx = MolSurad(1,:) > xh;
        MolSurad(1,Zx) = xh - (MolSurad(1,Zx)-xh);
        Zxx = MolSurad(1,:) < -xh;
        MolSurad(1,Zxx) = -xh - (MolSurad(1,Zxx)+xh);

        Zy = MolSurad(2,:) > yh;
        MolSurad(2,Zy) = yh - (MolSurad(2,Zy)-yh);
        Zyy = MolSurad(2,:) < -yh;
        MolSurad(2,Zyy) = -yh - (MolSurad(2,Zyy)+yh);

        Zz = MolSurad(3,:) > zh;
        MolSurad(3,Zz) = zh - (MolSurad(3,Zz)-zh);
        Zzz = MolSurad(3,:) < -zh;
        MolSurad(3,Zzz) = -zh - (MolSurad(3,Zzz)+zh);        
end
toc;

%     figure(2)
%     subplot(1,2,1)
%     plot3(  [  xh xh xh xh xh -xh -xh -xh -xh -xh -xh xh xh -xh -xh xh],...
%             [ -yh -yh yh yh -yh -yh -yh yh yh -yh -yh -yh yh yh yh yh],...
%             [ -zh zh zh -zh -zh -zh zh zh -zh -zh  zh zh zh zh -zh -zh],'b');hold on;
% 
%     plot3(MolSurad(1,:),MolSurad(2,:),MolSurad(3,:),'r.'); 
%         grid on
%     axis equal
%     xlabel('osa x') 
%     ylabel('osa y')
%     zlabel('osa z')
%     title(sprintf('PO korekcii, cas= %g s',t*dt))
%     hold off   
tic;
% ROTMAT = Rot_Z_ac * Rot_Y_ac * Rot_X_ac;
for i = 1:Nmol  % zrotovanie castic cez rotacne matice
            MolSurad(:,i) = Rot_Z_ac * (Rot_Y_ac * (Rot_X_ac * MolSurad(:,i))); % ROT_X okolo osi x, ROT_Y polarny uhol, ROT_Y azimut
%             MolSurad(:,i) = ROTMAT * MolSurad(:,i);
end
toc;                % opatovna korekcia
Zx = MolSurad(1,:) > xh;
MolSurad(1,Zx) = xh - (MolSurad(1,Zx)-xh);
Zxx = MolSurad(1,:) < -xh;
MolSurad(1,Zxx) = -xh - (MolSurad(1,Zxx)+xh);

Zy = MolSurad(2,:) > yh;
MolSurad(2,Zy) = yh - (MolSurad(2,Zy)-yh);
Zyy = MolSurad(2,:) < -yh;
MolSurad(2,Zyy) = -yh - (MolSurad(2,Zyy)+yh);

Zz = MolSurad(3,:) > zh;
MolSurad(3,Zz) = zh - (MolSurad(3,Zz)-zh);
Zzz = MolSurad(3,:) < -zh;
MolSurad(3,Zzz) = -zh - (MolSurad(3,Zzz)+zh);
    %% vykreslovanie 
%     figure(2)
%     subplot(1,2,2)
%     plot3(  [  xh xh xh xh xh -xh -xh -xh -xh -xh -xh xh xh -xh -xh xh],...
%             [ -yh -yh yh yh -yh -yh -yh yh yh -yh -yh -yh yh yh yh yh],...
%             [ -zh zh zh -zh -zh -zh zh zh -zh -zh  zh zh zh zh -zh -zh],'b');hold on;
% 
%     plot3(MolSurad(1,:),MolSurad(2,:),MolSurad(3,:),'r.');
%        
%     grid on
%     axis equal
%     xlabel('osa x') 
%     ylabel('osa y')
%     zlabel('osa z')
%     title(sprintf('PO korekcii, cas= %g s',t*dt))
%     hold off    
% %     pause;
%% snimanie utlmeneho signalu
tic;
%parametre
g = 25; % moment gradientu
        % vektory gradientov
vekt_grad = [1 0.166021035584538 -0.109966984346586 0.901242247736656 -0.169023062954173 -0.814711029327153 0.656034972800463 0.582240950764834 0.900188857785473 0.693299274570486 0.356853020673566 0.543141013283599 -0.525144171862385 -0.639216426303164 -0.329966097576598 -0.524029054233343 0.608760166496840 0.220054941778971 -0.00399900001786152 -0.510701220338259 0.413836899071192 -0.678930948983094 0.883948749254270 0.261995019342438 0.0879820327218876 0.293957983117846 0.887044830321646 0.256977069376366 0.0859930132036262 0.863254672276215;
             0 0.986122211362991 0.663801905510129 -0.419113115207297 -0.601083223878898 -0.385863013889912 0.366019984824630 0.800330932322818 0.259053959073882 -0.698301276551452 -0.923619053508023 -0.488126011938098 -0.396109129633467 0.689233459660286 -0.0129990038440270 -0.783043081039481 -0.0649740177704936 -0.233058938338440 -0.909845004063821 0.626633270356282 0.736708820327421 0.138985989556176 -0.295982916039870 0.431992031892894 0.184962068790273 -0.906868947918064 -0.0890039829748746 -0.442960119586403 0.866928133110757 0.504148808606242;
             0 0 0.739779894694929 -0.110030030245444 0.781108290930866 0.432846015581158 0.660035972634577 0.143058987902718 0.350072944694430 0.178077070524678 -0.139942008107261 -0.683177016708462 0.753207246499915 0.341115227494939 -0.943903279128288 0.335018034672023 -0.790689216254715 -0.947237749384605 -0.414929001853278 -0.588655253970947 0.534788869572764 -0.720926945827387 0.361978897319090 0.862984063711958 -0.978799364030720 0.301955982658516 -0.453022913343520 0.858923231884393 -0.490959075383333 -0.0250069905064104];
% sest smerov
% vekt_grad = [   1.0000    0.4067   -0.3291    0.2592   -0.3291    0.2592;
%                      0         0   -0.2391    0.7976    0.2391   -0.7976;
%                      0   -0.9135   -0.9135   -0.5446   -0.9135   -0.5446];
         
N = length(vekt_grad);  % pocet gradientov
jed = ones(1,Nmol);     % vektor "plneho signalu"
s = zeros(1,N);         % prazdny vektor pre jednotlive hodnoty

% simulacia merania
h = waitbar(0,'Simulacia merania'); figure(h);

for j = 1:N
    vek = vekt_grad(:,j);
    D = zeros(1,Nmol);
    for jj = 1:Nmol;
        D(jj) = sum(MolSurad(:,jj).*vek)/(sqrt(sum(vek.^2)) );
    end
    
    sig_s = jed.*exp(1i*2*pi*g*D);
    s(j) = abs(sum(sig_s));
    waitbar(j/30,h);
end
close(h);
toc;

%% vypocet tenzoru
tic;

hlad_vyznam = 0.05;             % zadanie hladiny vyznamnosti
T =1-hlad_vyznam;

diff_t = Ncas*dt;                           % difuzny cas
b = (2*pi*g)^2*diff_t;                      % b hodnota
[tenzor, Hmat,meze,mezei,Si,Yp,Y] = est_DT_HNP(b,Nmol,vekt_grad,s);     % stanovenie tenzoru
 Sp = ToDTISignal(N,g,vekt_grad,Nmol,diff_t,tenzor);
 [hraniceS]=extremCI_PP(tenzor,vekt_grad,Nmol,s,Sp,b,T);
 nn = 2;
 hranOdDo = [linspace(hraniceS(1,1),hraniceS(1,2),nn);           % vzorkovanie CIs 
                    linspace(hraniceS(2,1),hraniceS(2,2),nn);
                    linspace(hraniceS(3,1),hraniceS(3,2),nn);
                    linspace(hraniceS(4,1),hraniceS(4,2),nn);
                    linspace(hraniceS(5,1),hraniceS(5,2),nn);
                    linspace(hraniceS(6,1),hraniceS(6,2),nn);];
[PFCI,~,~] = CI_graf(hranOdDo,nn,Nmol,b,vekt_grad,s,s);
mas = max(PFCI,[],2);
mis = min(PFCI,[],2);

%% stanovenie teoretickeho signalu zo zadanych parametrov
 [tenzor_P]=param2tenz_5(zadane_P(1),zadane_P(2),zadane_P(3),zadane_P(4),zadane_P(5),zadane_P(6));
 S_fit_Za = ToDTISignal(N,g,vekt_grad,Nmol,diff_t,tenzor_P);
%% stanovenie parametrov zo stanoveneho tenzora 
[ADC,FA,alfa,psi,Pvv,gama]=tenz2param_3(tenzor);
parametre_EST   = [ADC,FA,alfa,psi,Pvv,gama];
%% vykreslenie konfidencnych intervalov predikcie
figure(1)
hold on
% plot(Si./Nmol,'m')
plot(mezei./Nmol,'y')
plot((S_fit_Za./Nmol)','g');
plot(Sp./Nmol,'b')
plot(s./Nmol,'r')
legend('Hranice CI','Hranice CI','Signal zo zadanych parametrov','Signal zo stanoveneho tenzoru','Namerany signal');
xlabel('Jednotlive smery gradientov, nezoradene')
ylabel('S/S0')
hold off
%% vypisanie konfide4n7ch intervalov jednotliv7ch parametrov

disp(['Polovica Sirka CI pre ADC: ',num2str((mas(1)-mis(1))/2),' s/mm^2 na hladine vyznamnosti: ',num2str(hlad_vyznam)])
disp(['Polovica Sirka CI pre FA: ',num2str((mas(2)-mis(2))/2),' na hladine vyznamnosti: ',num2str(hlad_vyznam)])
disp(['Polovica Sirka CI pre Azimuth: ',num2str((mas(3)-mis(3))/2),' rad, na hladine vyznamnosti: ',num2str(hlad_vyznam)])
disp(['Polovica Sirka CI pre Altitude: ',num2str((mas(4)-mis(4))/2),' rad, na hladine vyznamnosti: ',num2str(hlad_vyznam)])
disp(['Polovica Sirka CI pre Pomer medzi vedlajsimi poloosami : ',num2str((mas(5)-mis(5))/2)' na hladine vyznamnosti: ',num2str(hlad_vyznam)])
disp(['Polovica Sirka CI pre Torzny uhol: ',num2str((mas(6)-mis(6))/2),' rad, na hladine vyznamnosti: ',num2str(hlad_vyznam)])
disp(['Polovica Sirka CI pre Radialnu difusivitu: ',num2str((mas(7)-mis(7))/2),' s/mm^2 na hladine vyznamnosti: ',num2str(hlad_vyznam)])



%%
% figure(2)
% hold on
% plot(Y,'r*')
% plot(Yp,'b*')
% plot(meze,'y*')
% legend('Namerany signal','Signal zo stanoveneho tenzoru','Hranice CI','Hranice CI')
% xlabel('Jednotlive smery gradientov, nezoradene')
% hold off
% toc;
%%

% parametre = parametre_EST;
% variance = diag((0.01*Nmol)^2.*ones(1,N));


% %% postupne prechadzanie troch uhlov
% tic;
% % 6.parameter
% vekt = 0:0.01:2*pi;
% pst_odhadu6p = ones(1,length(vekt));
% pom = 0;
% for i=0:0.01:2*pi
%     pom = pom+1;
%     [tenzor_MC]=param2tenz_5(parametre(1),parametre(2),parametre(3),parametre(4),parametre(5),i);
%      S_p6 = ToDTISignal(N,g,vekt_grad,Nmol,diff_t,tenzor_MC);
%      pst_odhadu6p(pom) = (exp(-1/2*((S_p6-s)*variance^(-1)*(S_p6-s)')));
% end
% [m,n]=max(pst_odhadu6p);
% parametre(6) = vekt(n);
% figure()
% hold on
% plot((0:0.01:2*pi),pst_odhadu6p','g');
% 
% %% 3. a 4. a 6.parameter
% vekt = 0:0.01:2*pi;
% NOdhadovPPs = length(vekt);
% pst_odhadu3p4p = zeros(NOdhadovPPs);%,NOdhadovPPs,NOdhadovPPs);
% pom3p = 0;
% pom4p = 0;
% % pom6p = 0;
% % for k=1:0.1:2*pi
% %     pom6p = pom6p+1;
%     for i = 0:0.01:2*pi
%         pom3p = pom3p + 1;
%         for j = 0:0.01:2*pi
%             pom4p = pom4p +1;
%             [tenzor_MC]=param2tenz_5(parametre(1),parametre(2),i,j,parametre(5),parametre(6));
%             S_p34 = ToDTISignal(N,g,vekt_grad,Nmol,diff_t,tenzor_MC);
%             pst_odhadu3p4p(pom3p,pom4p) = (exp(-1/2*((S_p34-s)*variance^(-1)*(S_p34-s)')));
%         end
%         pom4p = 0;
%     end
% %     pom3p = 0;
% %     disp(k);
% % end
% %%
% figure()
% hold on
% surf(0:0.01:2*pi,0:0.01:2*pi,pst_odhadu3p4p)
% hold off
% % [j,k]=find(pst_odhadu3p4p==max(max(pst_odhadu3p4p)));
% % parametre(3) = vekt(j);
% % parametre(4) = vekt(k);
% % p6 = vekt(l);
% gral = max(max(pst_odhadu3p4p));
% for i=1:NOdhadovPPs
%     for j = 1:NOdhadovPPs
%         if pst_odhadu3p4p(i,j)==gral
%             parameter(3)=i*0.1-0.1;
%             parameter(4)=j*0.1-0.1;
%         end
%     end
% end
%             
% 
% disp(parametre);
% %%
% % overenie
% 
% [tenzor_P]=param2tenz_5(zadane_P(1),zadane_P(2),zadane_P(3),zadane_P(4),zadane_P(5),zadane_P(6));
%  S_fit_Za = ToDTISignal(N,g,vekt_grad,Nmol,diff_t,tenzor_P);
% 
% [tenzor_NGE]=param2tenz_5(parametre(1),parametre(2),parametre(3),parametre(4),parametre(5),parametre(6));
%  S_fit_MC = ToDTISignal(N,g,vekt_grad,Nmol,diff_t,tenzor_NGE);
% 
%  
%  figure()
% hold on
% plot(S_fit_Za','g');
% plot(S_fit_MC','r');
% 
% toc;






