clear all
% close all
%% nacitanie nameranych dat

% Data = load_nii('dwi-b1500.nii');       % nacitanie difuzne vazenych dat
% bval = load('bvals1500.txt');           % nacitanie b hodnot
% b = 1500;                               % b-hodnota

Data = load_nii('dwi-b0650.nii');       % nacitanie difuzne vazenych dat
bval = load('bvals0650.txt');           % nacitanie b hodnot
b = 650;                               % b-hodnota


DWIs = Data.img;                        % obrazove data
bvec = load('bvecs2.txt');               % nacitanie jednotkovych vektorov reprezentujucich difuzne vazeny gradient
% mask = load_nii('dwi-b2000_brain.nii');

% Meranie sa prevadzalo pod 130 smermi gradientov, pri4om v kazdom smere
% boli ziskane dve hodnoty, v konecnom dosledku sa data ziskali merani pod
% 64 nenulovy nekolinearnymi smermi difuzne kodujuci gradientov, volim
% sposob priemerovania intenzit...

S_all = double(DWIs);
S_fh = S_all(:,:,:,1:end/2);
S_sh = S_all(:,:,:,end/2+1:end);
S_av = (S_fh+S_sh)./2;

S0_3d = S_av(:,:,:,1);
S_4d = S_av(:,:,:,2:end);

NG = bvec(2:end/2,:)';                    % jednotkve vektory gradientov

%% pre konktretny voxel
ResStrADC = zeros(64);
ResStrFA = zeros(64);
ResStrAT = zeros(64);

AbsResCI_ADC = zeros(64);
AbsResCI_FA = zeros(64);
AbsResCI_uholy = zeros(64);
AbsResCI_uholz = zeros(64);

hlad_vyznam = 0.05;             % zadanie hladiny vyznamnosti
T =1-hlad_vyznam;
prahADC = 1.5e-4;               % zadanie prahovych hodnot
prahFA = 0.05;
prahAT = 0.35;
% x = 26; y = 25; z = 1;                  % zvolene suradnice
z = 1;
h = waitbar(0,'Pockaj si kamarat, pockaj si na mna...'); figure(h);
for x = 1:64
    parfor y = 1:64
        S0 = S0_3d(x,y,z);                                                  % signal0 diff gradientu
        preS = S_4d(x,y,z,:);                                               % difuzne gradienty
        S = double(reshape(preS,1,64));                                     % jednotlive signaly upravene pre spracovanie
        NSig = length(S);                                                   % pocet signalov
%         [tenzor, Hmat,meze,mezei,Si,Yp,Y] = est_DT_HN(b,S0,NG,S);           % vypocet tenzoru
        [tenzor] = est_DT_HN(b,S0,NG,S);           % vypocet tenzoru

        Sp = ToDTISignal_2(S0,b,NG,tenzor);

        % stanovenie jednoduchych CI pre prvky tenzora
        variance = diag((0.3*S0)^2.*ones(1,NSig));

        nn = 2;
        [hraniceS]=extremCI_PP(tenzor,NG,S0,S,Sp,b,T);                  % stanovenie CI pre jednotlive parametre
        hranOdDo = [linspace(hraniceS(1,1),hraniceS(1,2),nn);           % vzorkovanie CIs 
                    linspace(hraniceS(2,1),hraniceS(2,2),nn);
                    linspace(hraniceS(3,1),hraniceS(3,2),nn);
                    linspace(hraniceS(4,1),hraniceS(4,2),nn);
                    linspace(hraniceS(5,1),hraniceS(5,2),nn);
                    linspace(hraniceS(6,1),hraniceS(6,2),nn);];
%         [PFCI,SSs,PSTs] = CI_graf(hranOdDo,nn,S0,b,NG,S,variance);      % stanovenie mo6nych parametrov z CI pre jednotlive parametre
        [PFCI,~,~] = CI_graf(hranOdDo,nn,S0,b,NG,S,variance);
        mas = max(PFCI,[],2);
        mis = min(PFCI,[],2);
        Str = (mas+mis)./2;

        % vytvorenie binarnych obrazov cez prahy
        if Str(1)-mis(1) <prahADC; ResStrADC(x,y) = 1; else  ResStrADC(x,y)=0; end
        if Str(2)-mis(2) <prahFA; ResStrFA(x,y) = 1; else  ResStrFA(x,y)=0; end
        if Str(4)-mis(4) <prahAT; ResStrAT(x,y) = 1; else  ResStrAT(x,y)=0; end
        AbsResCI_ADC(x,y) = (mas(1)-mis(1))/2;
        AbsResCI_FA(x,y) = (mas(2)-mis(2))/2;
        AbsResCI_uholz(x,y) = (mas(3)-mis(3))/2;
        AbsResCI_uholy(x,y) = (mas(4)-mis(4))/2;

    end
    waitbar(x/64,h);   
end
close(h)

%%
figure(3)
imagesc(ResStrFA);
colormap(gray)
title(['FA binarna mapa na hladine vyznamnosti ',num2str(hlad_vyznam),' S prahom ',num2str(prahFA)]);
figure(4)
imagesc(ResStrADC);
colormap(gray);
title(['ADC binarna mapa na hladine vyznamnosti ',num2str(hlad_vyznam),' S prahom ',num2str(prahADC),' s/mm^2']);
%%
figure(9)
imagesc(ResStrAT);
colormap(gray)
title(['Altitude binarna mapa na hladine vyznamnosti ',num2str(hlad_vyznam),' S prahom ',num2str(prahAT)]);

%%
figure(5)
imagesc(AbsResCI_FA);
colormap(pink);
title(['Parameter FA, mapa rok konfidennch intervalov na hladine vyznamnosti ',num2str(hlad_vyznam)]);
figure(6)
imagesc(AbsResCI_ADC);
colormap(pink);
title(['Parameter ADC, mapa rok konfidennch intervalov na hladine vyznamnosti ',num2str(hlad_vyznam)]);
figure(7)
imagesc(AbsResCI_uholy);
colormap(pink);
title(['Altitude, mapa rok konfidennch intervalov na hladine vyznamnosti ',num2str(hlad_vyznam)]);
figure(8)
imagesc(AbsResCI_uholz);
colormap(pink);
title(['Azimuth, mapa rok konfidennch intervalov na hladine vyznamnosti ',num2str(hlad_vyznam)]);
%% stanovenie extremnych CI, definovane ako extremy na hyperelipsoide (Meloun)
% b(j)+-p*sqrt(C(j,j))
% p^2 = m * sigma.^2 * F(m,n-m,kvantil)

% [hraniceE]=extremCI_PP(tenzor,NG,S0,S,Sp,b,T);






%% vykreslenie
% figure(3)
% hold on
% plot(Si./S0,'m')
% plot(mezei./S0,'y')
% plot(Sp./S0,'b')
% plot(Sp_ine./S0,'g')
% plot(S./S0,'r')
% hold off
% % normovanie k vykresleniu aby stredy intervalov lezali na jednej urovnic
% KkS = 1-Yp';
% figure(4)
% hold on
% plot(Y+KkS,'r*')
% plot(Yp'+KkS,'b*')
% plot((meze'+[KkS; KkS])','y*')
% hold off
% 
% %%
% 
%% lepsi odhad parametrov
% 
% [ADC,FA,alfa,psi,Pvv,gama]=tenz2param_3(tenzor);
% parametre_EST   = [ADC,FA,alfa,psi,Pvv,gama];
% disp(parametre_EST);
% % parametre = parametre_EST;
% variance = diag((0.3*S0)^2.*ones(1,NSig));


