
clear all
% close all
%% vyber dat a volba parametrov analyzy
% matlabpool;    % vypocet vyuziva paralelny for, STACI PUSTIT RAZ

subjekt     = '73'; % vyber subjektu zadanie cisla z jeho nazvu
hlad_vyznam = 0.05; % volba hladiny vyznamnosti na ktorej sa budu stanovovat CI
b           = 1000; % 500,1000,1500,2000,2500  % volba b-hodnoty

% prahADC = 4e-4;
% prahFA = 0.13;

% DKI data after eddy current correction (FSL). Data are in NIFTI format.
% GMO mice: 
% pl_pd67 - done
% pl_pd69 - done
% pl_pd71 - done
% pl_pd73 - done
% pl_pd77 - done
% pl_pd79
% 
% WT mice:
% pl_pd68 - done
% pl_pd70 - done
% pl_pd72 - nope
% pl_pd74
% pl_pd75



%% nacitanie dat
x67 = load_nii(['pl_pd',subjekt,'_eddy.nii']);
Obr_data = x67.img;

S0_4d = Obr_data(:,:,:,1:7);
S0_3d = sum(S0_4d,4)./7;


b_valsEF = load('bval.bval');       % nacitanie efektivnych b-hodnot

if b == 500; 
    S_4d = Obr_data(:,:,:,[8:5:153]);       % DW-data   indexovanie z prezrietia dat
    bs = b_valsEF(8:5:153);                 % efektivne B-hodnoty
    b = mean(bs);                           % priemer z efekt.B-hodnot
elseif b == 1000; 
    S_4d = Obr_data(:,:,:,[9:5:154]);
    bs = b_valsEF(9:5:154);
    b = mean(bs);
elseif b == 1500; 
    S_4d = Obr_data(:,:,:,[10:5:155]);
    bs = b_valsEF(10:5:155);
    b = mean(bs); 
elseif b == 2000; 
    S_4d = Obr_data(:,:,:,[11:5:156]);
    bs = b_valsEF(11:5:156);
    b = mean(bs);
elseif b == 2500; 
    S_4d = Obr_data(:,:,:,[12:5:157]);
    bs = b_valsEF(12:5:157);
    b = mean(bs);
end


load('SmerVec.mat');
NG = SmerVec';

   
ROI = [240,170,15];                 % vyticena oblast - hlavne s cielom skratit vypocet
%% vytvorenie prazdnych premennych s idealnou velkostou
ResStrADC = zeros(ROI);
ResStrFA = zeros(ROI);

AbsResCI_ADC = zeros(ROI);
AbsResCI_FA = zeros(ROI);
AbsResCI_uholy = zeros(ROI);
AbsResCI_uholz = zeros(ROI);
AbsResCI_uholx = zeros(ROI);
AbsResCI_pomer = zeros(ROI);
AbsResCI_RadDi = zeros(ROI);


T =1-hlad_vyznam; 

% x = 138; y = 111; z = 2;                  % zvolene suradnice
z = 8;
h = waitbar(0,'Pockaj si kamarat, pockaj si na mna...'); figure(h);
ha = waitbar(0,'Az kym JA dojdem do konca, vtedy bude koniec'); figure(ha);
 for z = 1:15
for x = 1:ROI(1)
    parfor y = 1:ROI(2)
        S0 = S0_3d(x,y,z);                                                  % signal0 diff gradientu
        preS = S_4d(x,y,z,:);                                               % difuzne gradienty
        S = double(reshape(preS,1,30));                                     % jednotlive signaly upravene pre spracovanie
        
        NSig = length(S);                                                   % pocet signalov
%         [tenzor, Hmat,meze,mezei,Si,Yp,Y] = est_DT_HN(bs,S0,NG,S);          % vypocet tenzoru
         [tenzor] = est_DT_HN(bs,S0,NG,S);          % vypocet tenzoru

        Sp = ToDTISignal_2(S0,b,NG,tenzor);                                 % stanovenie teoretickych nameranych hodnot

        % stanovenie jednoduchych CI pre prvky tenzora
        variance = diag((0.3*S0)^2.*ones(1,NSig));

        nn = 2;                                                             % volba poctu bodov na intervalu CI prvkov tenzora pre prechod k CI parametrov elipsoidu
        [hraniceS]=extremCI_PP(tenzor,NG,S0,S,Sp,b,T);                      % stanovenie CI pre jednotlive parametre
        hranOdDo = [linspace(hraniceS(1,1),hraniceS(1,2),nn);               % vzorkovanie CIs 
                    linspace(hraniceS(2,1),hraniceS(2,2),nn);
                    linspace(hraniceS(3,1),hraniceS(3,2),nn);
                    linspace(hraniceS(4,1),hraniceS(4,2),nn);
                    linspace(hraniceS(5,1),hraniceS(5,2),nn);
                    linspace(hraniceS(6,1),hraniceS(6,2),nn);];
%         [PFCI,SSs,PSTs] = CI_graf(hranOdDo,nn,S0,b,NG,S,variance);                                 
        [PFCI,~,~] = CI_graf(hranOdDo,nn,S0,b,NG,S,variance);               % stanovenie parametrov z CI pre jednotlive prvky tenzora
        mas = max(PFCI,[],2);                                       % horne hranice jednotlivych parametrov difuzie
        mis = min(PFCI,[],2);                                       % spodne hranice
%         Str = (mas+mis)./2;                                         

        % vytvorenie binarnych obrazov cez prahy
%         if Str(1)-mis(1) <prahADC; ResStrADC(x,y) = 1; else  ResStrADC(x,y)=0; end
%         if Str(2)-mis(2) <prahFA; ResStrFA(x,y) = 1; else  ResStrFA(x,y)=0; end
        AbsResCI_ADC(x,y,z) = (mas(1)-mis(1))/2;
        AbsResCI_FA(x,y,z) = (mas(2)-mis(2))/2;
        AbsResCI_uholz(x,y,z) = (mas(3)-mis(3))/2;
        AbsResCI_uholy(x,y,z) = (mas(4)-mis(4))/2;
%         AbsResCI_uholx(x,y,z) = (mas(5)-mis(5))/2;
%         AbsResCI_pomer(x,y,z) = (mas(6)-mis(6))/2;
        AbsResCI_RadDi(x,y,z) = (mas(7)-mis(7))/2;
    end
%     disp(x);
    waitbar(x/240,h);
end
waitbar(z/15,ha)
end
close(h);
%% ulozenie vysledkov do formatu .nii
AbsResCI_ADC_nii = make_nii(AbsResCI_ADC); 
save_nii(AbsResCI_ADC_nii,['CI_ADC_',subjekt,'_',num2str(b),'.nii'],[]);

AbsResCI_FA_nii = make_nii(AbsResCI_FA);
save_nii(AbsResCI_FA_nii,['CI_FA_',subjekt,'_',num2str(b),'.nii'],[]);

AbsResCI_uholz_nii = make_nii(AbsResCI_uholz);
save_nii(AbsResCI_uholz_nii,['CI_Azim_',subjekt,'_',num2str(b),'.nii'],[]);

AbsResCI_uholy_nii = make_nii(AbsResCI_uholy);
save_nii(AbsResCI_uholy_nii,['CI_Alti_',subjekt,'_',num2str(b),'.nii'],[]);

AbsResCI_RadDi_nii = make_nii(AbsResCI_RadDi);
save_nii(AbsResCI_RadDi_nii,['CI_RadDif_',subjekt,'_',num2str(b),'.nii'],[]);
% %%
% figure(3)
% imagesc(ResStrFA);
% colormap(gray)
% title(['FA binarna mapa na hladine vyznamnosti ',num2str(hlad_vyznam),' S prahom ',num2str(prahFA)]);
% figure(4)
% imagesc(ResStrADC);
% colormap(gray);
% title(['ADC binarna mapa na hladine vyznamnosti ',num2str(hlad_vyznam),' S prahom ',num2str(prahADC),' s/mm^2']);
% %%
% figure(9)
% imagesc(ResStrAT);
% colormap(gray)
% title(['Altitude binarna mapa na hladine vyznamnosti ',num2str(hlad_vyznam),' S prahom ',num2str(prahAT)]);
% 
%%
% figure(5)
% imagesc(AbsResCI_FA(:,:,8));
% colormap(pink);
% title(['Parameter FA, mapa rok konfidennch intervalov na hladine vyznamnosti ',num2str(hlad_vyznam)]);
% figure(6)
% imagesc(AbsResCI_ADC(:,:,8));
% colormap(pink);
% title(['Parameter ADC, mapa rok konfidennch intervalov na hladine vyznamnosti ',num2str(hlad_vyznam)]);
% figure(7)
% imagesc(AbsResCI_uholy(:,:,8));
% colormap(pink);
% title(['Altitude, mapa rok konfidennch intervalov na hladine vyznamnosti ',num2str(hlad_vyznam)]);
% figure(8)
% imagesc(AbsResCI_uholz(:,:,8));
% colormap(pink);
% title(['Azimuth, mapa rok konfidennch intervalov na hladine vyznamnosti ',num2str(hlad_vyznam)]);
% % figure(10)
% % imagesc(AbsResCI_uholx(:,:,8));
% % colormap(pink);
% 
% figure(11)
% imagesc(AbsResCI_pomer(:,:,8));
% colormap(pink);
% 
% figure(12)
% imagesc(AbsResCI_RadDi(:,:,8));
% colormap(pink);










