close all; clear all;
%% zakladne parametre vonk
Nmol = 10000;                       %pocet casti ktore v tejto casti difunduj[
D = 70;                         % VYMYSLEN8 DOKONCI NESKOR, podla rozmeru comparmentu / NAHRAD FUNKCIOU
dt = 1;
Dkonst = sqrt(2*D*dt);
xh = 300;                             % velkost oblasti kde mozu difundovat / NAHRAD FUNKCIOU (tvar, velkost)
yh = 300;
zh = 300;
Ncas = 200;                         % pocet casovych krokov / POZRI SI JEDNOTKU NAPR. ms

MolSurad = zeros(3,Nmol);
ophi   = (0:15:360)/180*pi;
z = zeros(1,length(ophi));

%% param vnutorne

% prietor 
x_ssp = 300;
y_ssp = 300;
z_ssp = 300;
r = 400;
stred = [x_ssp,y_ssp,z_ssp];
ophi   = (0:15:360)/180*pi;
z = zeros(1,length(ophi));


r_sp = [r];
x_sp = [x_ssp];
y_sp = [y_ssp];
z_sp = [z_ssp];

% castice
N = 1000;
Nvs = ones(1,1000);
Nsurad = [x_ssp.*Nvs; y_ssp.*Nvs; z_ssp.*Nvs];



%%
   
for t=1:Ncas;
    MolSurad_old = MolSurad;
    
    
    MolSurad = MolSurad_old + Dkonst*randn(3,Nmol);
    
       
    %% "odraz" mol od hranice priestoru
    Zx = MolSurad(1,:) > xh;
    MolSurad(1,Zx) = xh - (MolSurad(1,Zx)-xh);
    Zxx = MolSurad(1,:) < -xh;
    MolSurad(1,Zxx) = -xh - (MolSurad(1,Zxx)+xh);
    
    Zy = MolSurad(2,:) > yh;
    MolSurad(2,Zy) = yh - (MolSurad(2,Zy)-yh);
    Zyy = MolSurad(2,:) < -yh;
    MolSurad(2,Zyy) = -yh - (MolSurad(2,Zyy)+yh);
    
    Zz = MolSurad(3,:) > zh;
    MolSurad(3,Zz) = zh - (MolSurad(3,Zz)-zh);
    Zzz = MolSurad(3,:) < -zh;
    MolSurad(3,Zzz) = -zh - (MolSurad(3,Zzz)+zh);
     

    for j=1:length(r_sp)
        xn = [MolSurad(1,:)-x_sp(j);MolSurad(2,:)-y_sp(j);MolSurad(3,:)-z_sp(j)];
        eukvz = sqrt(sum(xn.^2,1));
        Ind = eukvz < r_sp(j);
        Ind = Ind.*(1:length(Ind));
        Ind = Ind(Ind>0);
        konst = 2.*((r_sp(j)-eukvz)./eukvz);
        MolSurad(:,Ind) = MolSurad(:,Ind) + [konst(Ind);konst(Ind);konst(Ind)].*xn(:,Ind);
    end
    
    Nsurad_o = Nsurad;
    Nsurad = Nsurad_o + Dkonst*randn(3,N);
    I=[];
    konsts=[];
    
    % zistovanie ktora zastica vysla mimo vymedzeny priestor gule
    xn = [x_ssp-Nsurad(1,:); y_ssp-Nsurad(2,:); z_ssp-Nsurad(3,:)];
    eukvzs = sqrt(sum(xn.^2,1));
    I = eukvzs > r;
    I = I.*(1:length(I));
    I =I(I>0);
    
    % korekcia castic v zakazanom uzemi
    konsts = 2.*((r-eukvzs)./eukvzs);
    Nsurad(:,I) = Nsurad(:,I) - [konsts(I);konsts(I);konsts(I)].*xn(:,I);
    
    Zx = Nsurad(1,:) > xh;
    Nsurad(1,Zx) = xh - (Nsurad(1,Zx)-xh);
    Zxx = Nsurad(1,:) < -xh;
    Nsurad(1,Zxx) = -xh - (Nsurad(1,Zxx)+xh);
    
    Zy = Nsurad(2,:) > yh;
    Nsurad(2,Zy) = yh - (Nsurad(2,Zy)-yh);
    Zyy = Nsurad(2,:) < -yh;
    Nsurad(2,Zyy) = -yh - (Nsurad(2,Zyy)+yh);
    
    Zz = Nsurad(3,:) > zh;
    Nsurad(3,Zz) = zh - (Nsurad(3,Zz)-zh);
    Zzz = Nsurad(3,:) < -zh;
    Nsurad(3,Zzz) = -zh - (Nsurad(3,Zzz)+zh);
    
    % vykreslenie
    figure(1)
%     subplot(2,1,1)
    plot3(  [  xh xh xh xh xh -xh -xh -xh -xh -xh -xh xh xh -xh -xh xh],...
            [ -yh -yh yh yh -yh -yh -yh yh yh -yh -yh -yh yh yh yh yh],...
            [ -zh zh zh -zh -zh -zh zh zh -zh -zh  zh zh zh zh -zh -zh],'b');hold on;
    plot3(MolSurad(1,:),MolSurad(2,:),MolSurad(3,:),'r.');
    
%     for j=1:length(r_sp)
%         oframe = [cos(ophi);sin(ophi)]*r_sp(j);
%         plot3(oframe(1,:)+x_sp(j),oframe(2,:)+y_sp(j),z+z_sp(j),'g');
%         plot3(oframe(1,:)+x_sp(j),z+y_sp(j),oframe(2,:)+z_sp(j),'g');
%         plot3(z+x_sp(j),oframe(1,:)+y_sp(j),oframe(2,:)+z_sp(j),'g');
%     end
    
    oframe = [cos(ophi);sin(ophi)]*r;
%     plot3( oframe(1,:)+x_ssp, oframe(2,:)+y_ssp, z+z_ssp, 'g'); hold on
%     plot3(oframe(1,:)+x_ssp, z+y_ssp ,oframe(2,:)+z_ssp, 'g');
%     plot3(z+x_ssp ,oframe(1,:)+y_ssp ,oframe(2,:)+z_ssp, 'g');
    plot3(Nsurad(1,:),Nsurad(2,:),Nsurad(3,:), 'b.')
    
    grid on
    axis equal
    xlabel('osa x') 
    ylabel('osa y')
    zlabel('osa z')
    title(sprintf('PO korekcii, cas= %d',t))
    hold off

   
end




























