function [DT]=est_DT_HN(b,S0,NG,S)
%stanovenie tenzoru difuzie zo siestich merani
%b - b-hodnota pre dane meranie(skalarna hodnota)
%S0 - intenzita signalu bez pouzitia DWGs
%NG - matica o velkosti 3xN, obsahuje suradnice normalizovane zlozky
%vahujuceho gradientu pre kazde zo siestich merani
%S - vektor intenzit signalu, pozicia vo vektore odpoveda poradiu v snimani


N = length(NG);

for i=1:N
    Hmat(i,1)=NG(1,i)^2;
    Hmat(i,2)=NG(2,i)^2;
    Hmat(i,3)=NG(3,i)^2;
    Hmat(i,4)=NG(1,i)*NG(2,i)*2;
    Hmat(i,5)=NG(1,i)*NG(3,i)*2;
    Hmat(i,6)=NG(2,i)*NG(3,i)*2;
end

if length(b)==1; 
    Y = (log(S0./S))./b; 
elseif length(b) == N; 
    Y = (log(S0./S))./b;
else
    error('Chybne zadana b-hodnota');
end

d=(Hmat'*Hmat)^(-1)*Hmat'*Y';

DT=[d(1) d(4) d(5); 
     d(4) d(2) d(6); 
     d(5) d(6) d(3)];



















    