function [DT,Hmat,meze,mezei,Si,Yp,Y]=est_DT_HNP(b,S0,NG,S)
%stanovenie tenzoru difuzie zo siestich merani
%b - b-hodnota pre dane meranie(skalarna hodnota)
%S0 - intenzita signalu bez pouzitia DWGs
%NG - matica o velkosti 3xN, obsahuje suradnice normalizovane zlozky
%vahujuceho gradientu pre kazde zo siestich merani
%S - vektor intenzit signalu, pozicia vo vektore odpoveda poradiu v snimani

% 

%  NG =    [ 1.0000    0.4067   -0.4067    0.4067   -0.4067    0.4067  ;
%                 0         0    0.5370    0.8688   -0.5370   -0.8688  ;
%                 0   -0.9135   -0.7391   -0.2823   -0.7391   -0.2823 ];
% b = 444;
% S0 = 10000;
% S = [4.1488    5.9414    5.9648    5.9414    5.9648    5.9414].*1000;
N = length(NG);

for i=1:N
    Hmat(i,1)=NG(1,i)^2;
    Hmat(i,2)=NG(2,i)^2;
    Hmat(i,3)=NG(3,i)^2;
    Hmat(i,4)=NG(1,i)*NG(2,i)*2;
    Hmat(i,5)=NG(1,i)*NG(3,i)*2;
    Hmat(i,6)=NG(2,i)*NG(3,i)*2;
end

if length(b)==1; 
    Y = (log(S0./S))./b; 
elseif length(b) == N; 
    Y = (log(S0./S))./b;
else
    error('Chybne zadana b-hodnota');
end

d=(Hmat'*Hmat)^(-1)*Hmat'*Y';

DT=[d(1) d(4) d(5); 
     d(4) d(2) d(6); 
     d(5) d(6) d(3)];

%% est credible region
% stanovi sa pre kazdu hodnotu pre kazdy gradient
% nutne parametre Hmat, b-odhad regresnych parametrov, kvantil studentova
% rozlozenia, odhad rozptylu predikce

Yp = Hmat*d;                        % predikce
% Si = S0.*exp(-Yp.*b);

RSC = sum((Y-Yp').^2);               % rezidua suctu stvorcov
REZp2 = (RSC/(N-6));     % odhad rezidu8lnej smerodatnej odchylky

% RSC = sum((S-Si').^2);
% REZp2 = (RSC/(N-6));

K = tinv(0.995,N-6);   % STANOVENE PRE n-m, n=30,m=6 UPRAVIT NA FUNCIu, kvantil studentova rozdelenia

meze = zeros(N,2);

for ii = 1:N
    meze(ii,1) = Hmat(ii,:)*d - K*sqrt(REZp2.*Hmat(ii,:)*(Hmat'*Hmat)^(-1)*Hmat(ii,:)');
    meze(ii,2) = Hmat(ii,:)*d + K*sqrt(REZp2.*Hmat(ii,:)*(Hmat'*Hmat)^(-1)*Hmat(ii,:)');
end

% mezei = meze;

%% uprava na povodne hodnoty
b=mean(b);
Si = S0.*exp(-Yp.*b);
mezei = S0.*exp(-meze.*b);

















    