function [meze]=extremCI_PP(tenzor,grad,S0,Sp,Sn,b,T)
% funkcia stanoviem hranice konfidencnych intervalov pre jednotlive prvy
% tenozru algoritmus je podobny ako pri stanoveni tenzoru, avsak tenzor uz
% stanoveny a my sa chceme pozriet ako dobre

N = length(grad);
Hmat= zeros(N,6);
for i=1:N
    Hmat(i,1)=grad(1,i)^2;
    Hmat(i,2)=grad(2,i)^2;
    Hmat(i,3)=grad(3,i)^2;
    Hmat(i,4)=grad(1,i)*grad(2,i)*2;
    Hmat(i,5)=grad(1,i)*grad(3,i)*2;
    Hmat(i,6)=grad(2,i)*grad(3,i)*2;
end

Yp = (log(S0./Sp))./b;      
Yn = (log(S0./Sn))./b;


M = (Hmat'*Hmat)^(-1);
d = [tenzor(1),tenzor(5),tenzor(9),tenzor(4),tenzor(7),tenzor(8)]';
K = finv(T,6,N-6);

RSC = sum((Yn-Yp).^2);               % rezidua suctu stvorcov
REZp = sqrt(RSC/(N-6));     % odhad rezidu8lnej smerodatnej odchylky

p = sqrt( 6*REZp^2*K );

meze = zeros(6,2);
for j=1:6
meze(j,1) = d(j)-p*sqrt(M(j,j));
meze(j,2) = d(j)+p*sqrt(M(j,j));
end