% model DTI fitovanie
tic;
clear all;


%% model nahodneho pohybu castic
    % parametre 
D_x = 0.002;
D_y = 0.001;  
D_z = 0.00048;  
uhol_y = pi/4;     
uhol_z = pi/4;  
uhol_x = pi/16; 

% % nahodne nastavenie parametrov
% Eig_val = sort([(0.5+2.5*rand(1,3)).*0.001],'descend');
% Eig_val(3) =  Eig_val(2)*(1-(rand(1)/4));
% % 
% % 
% D_x = Eig_val(1);
% D_y = Eig_val(3);
% D_z = Eig_val(2);
% uhol_y = rand(1)*pi-pi/2;              % polarny
% uhol_z = rand(1)*pi-pi/2;              % azimut
% uhol_x = rand(1)*pi-pi/2;              % torny uhol
 %%

    % parametre
Nmol = 10000;                              % pocet castic
MolSurad = zeros(3,Nmol);                   % vsetky castice zacinaju z rovnakeho bodu
dt = 0.0005;                                % [s] casovy usek 
Ncas = 100;                                 % pocet casovych usekov
Dkonst_x = sqrt(2*D_x*dt);     % smerodatne odchylky vzdialenosti, za casovy usek
Dkonst_y = sqrt(2*D_y*dt);       
Dkonst_z = sqrt(2*D_z*dt);
xh = 0.05;                                  % ohranicenie[mm]      
yh = 0.05;
zh = 0.05;
Rot_Y_ac = [cos(uhol_y) 0 -sin(uhol_y);0 1 0 ; sin(uhol_y) 0 cos(uhol_y)];   % uhly pre stocenie vsetkych castic
Rot_Z_ac = [cos(uhol_z) sin(uhol_z) 0; -sin(uhol_z) cos(uhol_z) 0; 0 0 1];   % rotacne matice
Rot_X_ac = [1 0 0; 0 cos(uhol_x) sin(uhol_x); 0 -sin(uhol_x) cos(uhol_x)];
    % odvodene parametre
ADC0 = sqrt(1/2)*( (sqrt((D_x-D_y)^2+(D_y-D_z)^2+(D_z-D_x)^2))/(sqrt(D_x^2+D_y^2+D_z^2)) );
Pvv0 = D_y/D_z;
if Pvv0 > 1 
    Pvv0 = D_z/D_y;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
zadane_P = [D_x,ADC0,uhol_y,uhol_z,Pvv0,uhol_x];        %%%%%%%%%%%% SVATY GRAL %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% simulacia
for t=1:Ncas
        nah = randn(3,Nmol);
        MolSurad(1,:) = MolSurad(1,:) + Dkonst_x.*nah(1,:);
        MolSurad(2,:) = MolSurad(2,:) + Dkonst_y.*nah(2,:);
        MolSurad(3,:) = MolSurad(3,:) + Dkonst_z.*nah(3,:);

        % korekcia castic za hranicou vymedzeneho priestoru
        Zx = MolSurad(1,:) > xh;
        MolSurad(1,Zx) = xh - (MolSurad(1,Zx)-xh);
        Zxx = MolSurad(1,:) < -xh;
        MolSurad(1,Zxx) = -xh - (MolSurad(1,Zxx)+xh);

        Zy = MolSurad(2,:) > yh;
        MolSurad(2,Zy) = yh - (MolSurad(2,Zy)-yh);
        Zyy = MolSurad(2,:) < -yh;
        MolSurad(2,Zyy) = -yh - (MolSurad(2,Zyy)+yh);

        Zz = MolSurad(3,:) > zh;
        MolSurad(3,Zz) = zh - (MolSurad(3,Zz)-zh);
        Zzz = MolSurad(3,:) < -zh;
        MolSurad(3,Zzz) = -zh - (MolSurad(3,Zzz)+zh);
end

    figure(2)
    subplot(1,2,1)
    plot3(  [  xh xh xh xh xh -xh -xh -xh -xh -xh -xh xh xh -xh -xh xh],...
            [ -yh -yh yh yh -yh -yh -yh yh yh -yh -yh -yh yh yh yh yh],...
            [ -zh zh zh -zh -zh -zh zh zh -zh -zh  zh zh zh zh -zh -zh],'b');hold on;

    plot3(MolSurad(1,:),MolSurad(2,:),MolSurad(3,:),'r.'); 
        grid on
    axis equal
    xlabel('osa x') 
    ylabel('osa y')
    zlabel('osa z')
    title(sprintf('PO korekcii, cas= %g s',t*dt))
    hold off   

for i = 1:Nmol  % zrotovanie castic cez rotacne matice
            MolSurad(:,i) = Rot_Z_ac * (Rot_Y_ac * (Rot_X_ac * MolSurad(:,i)));
end
                % opatovna korekcia
Zx = MolSurad(1,:) > xh;
MolSurad(1,Zx) = xh - (MolSurad(1,Zx)-xh);
Zxx = MolSurad(1,:) < -xh;
MolSurad(1,Zxx) = -xh - (MolSurad(1,Zxx)+xh);

Zy = MolSurad(2,:) > yh;
MolSurad(2,Zy) = yh - (MolSurad(2,Zy)-yh);
Zyy = MolSurad(2,:) < -yh;
MolSurad(2,Zyy) = -yh - (MolSurad(2,Zyy)+yh);

Zz = MolSurad(3,:) > zh;
MolSurad(3,Zz) = zh - (MolSurad(3,Zz)-zh);
Zzz = MolSurad(3,:) < -zh;
MolSurad(3,Zzz) = -zh - (MolSurad(3,Zzz)+zh);
    %% vykreslovanie 
    figure(2)
    subplot(1,2,2)
    plot3(  [  xh xh xh xh xh -xh -xh -xh -xh -xh -xh xh xh -xh -xh xh],...
            [ -yh -yh yh yh -yh -yh -yh yh yh -yh -yh -yh yh yh yh yh],...
            [ -zh zh zh -zh -zh -zh zh zh -zh -zh  zh zh zh zh -zh -zh],'b');hold on;

    plot3(MolSurad(1,:),MolSurad(2,:),MolSurad(3,:),'r.');
       
    grid on
    axis equal
    xlabel('osa x') 
    ylabel('osa y')
    zlabel('osa z')
    title(sprintf('PO korekcii, cas= %g s',t*dt))
    hold off    
%     pause;
%% snimanie utlmeneho signalu
%parametre
g = 25; % moment gradientu
        % vektory gradientov
vekt_grad = [1 0.166021035584538 -0.109966984346586 0.901242247736656 -0.169023062954173 -0.814711029327153 0.656034972800463 0.582240950764834 0.900188857785473 0.693299274570486 0.356853020673566 0.543141013283599 -0.525144171862385 -0.639216426303164 -0.329966097576598 -0.524029054233343 0.608760166496840 0.220054941778971 -0.00399900001786152 -0.510701220338259 0.413836899071192 -0.678930948983094 0.883948749254270 0.261995019342438 0.0879820327218876 0.293957983117846 0.887044830321646 0.256977069376366 0.0859930132036262 0.863254672276215;
             0 0.986122211362991 0.663801905510129 -0.419113115207297 -0.601083223878898 -0.385863013889912 0.366019984824630 0.800330932322818 0.259053959073882 -0.698301276551452 -0.923619053508023 -0.488126011938098 -0.396109129633467 0.689233459660286 -0.0129990038440270 -0.783043081039481 -0.0649740177704936 -0.233058938338440 -0.909845004063821 0.626633270356282 0.736708820327421 0.138985989556176 -0.295982916039870 0.431992031892894 0.184962068790273 -0.906868947918064 -0.0890039829748746 -0.442960119586403 0.866928133110757 0.504148808606242;
             0 0 0.739779894694929 -0.110030030245444 0.781108290930866 0.432846015581158 0.660035972634577 0.143058987902718 0.350072944694430 0.178077070524678 -0.139942008107261 -0.683177016708462 0.753207246499915 0.341115227494939 -0.943903279128288 0.335018034672023 -0.790689216254715 -0.947237749384605 -0.414929001853278 -0.588655253970947 0.534788869572764 -0.720926945827387 0.361978897319090 0.862984063711958 -0.978799364030720 0.301955982658516 -0.453022913343520 0.858923231884393 -0.490959075383333 -0.0250069905064104];
% sest smerov
% vekt_grad = [   1.0000    0.4067   -0.3291    0.2592   -0.3291    0.2592;
%                      0         0   -0.2391    0.7976    0.2391   -0.7976;
%                      0   -0.9135   -0.9135   -0.5446   -0.9135   -0.5446];
         
N = length(vekt_grad);  % pocet gradientov
jed = ones(1,Nmol);     % vektor "plneho signalu"
s = zeros(1,N);         % prazdny vektor pre jednotlive hodnoty

% simulacia merania
for j = 1:N
    vek = vekt_grad(:,j);
    D = zeros(1,Nmol);
    for jj = 1:Nmol;
        D(jj) = sum(MolSurad(:,jj).*vek)/(sqrt(sum(vek.^2)) );
    end
    sig_s = jed.*exp(1i*2*pi*g*D);
    s(j) = abs(sum(sig_s));
end

%% vypocet tenzoru
diff_t = Ncas*dt;                           % difuzny cas
b = (2*pi*g)^2*diff_t;                      % b hodnota
[tenzor] = est_DT_HN(b,Nmol,vekt_grad,s);     % stanovenie tenzoru

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%      FITOVANIE, ODHAD CONFIDENCNYCH A KREDIBILNYCH OBLASTI    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% pociatocne paramtre
[ADC,FA,alfa,psi,Pvv,gama]=tenz2param_3(tenzor);
parametre_EST   = [ADC,FA,alfa,psi,Pvv,gama];                 % parametre = [0.0011,0.35,2.3,0.8,0.8,5.2];

parametre = [0.002 0.4 0 0 0.8 0];
sigmae = [0.0015, 0.2, pi/2, pi/2, 0.3, pi];
Nguess      = 10000;
Nupdates    = 50;

% zname
Nparam      = length(parametre);
CovM        = zeros(Nparam);
CorM        = zeros(Nparam);
V           = eye(Nparam);
fAntiDimCollapse = 0;
VZ          = 0.8;           % miera priklonenia sa k nov7m parametrom
VS          = 0.6;          % miera priklonenia k novym smerodatnym odchylkam
kur_param   = 1;
variance = diag(100000.*ones(1,N));

pst_odhadu = zeros(1,Nguess);
podhadu_tenz = zeros(1,Nguess*Nupdates);
S_fit_hist = zeros(30,Nguess*Nupdates);
parametre_hist = zeros(6,(Nguess*Nupdates+1));
parametre_iter = zeros(6,Nguess);
hist_sigmae = zeros(Nupdates,Nparam);

h = waitbar(0,'Pockaj si kamarat, pockaj si na mna...'); figure(h);

%% prvy odhadovy siroko rozlahly
parfor i=1:1000000
    pz=GenParam(parametre,sigmae,Nparam);
    parametre_iter(:,i) = pz;
    [tenzor_s]=param2tenz_5(pz(1),pz(2),pz(3),pz(4),pz(5),pz(6));
    S_fit = ToDTISignal(N,g,vekt_grad,Nmol,diff_t,tenzor_s);
    if any(isinf(S_fit))
        pst_odhadu(i) = 0;
    else
    pst_odhadu(i) = exp(-1/2*((S_fit-s)*variance^(-1)*(S_fit-s)'));
    end
end

Spst = sum(pst_odhadu);
parametre = (sum(parametre_iter'.*( pst_odhadu'*ones(1,6)))./Spst);
disp(parametre)

%% druhy upresnucuji MC cyklus
pst_odhadu = zeros(1,Nguess);
parametre_iter = zeros(6,Nguess);
tic;
for j=1:Nupdates
    S_fit_iter = zeros(30,Nguess);
    I = 1:j*Nguess;                                                          % indexy uz vyppocitanych hodnot
    parfor i=1:Nguess
        pz=GenParam(parametre,sigmae,Nparam);
        parametre_iter(:,i) = pz';
        [tenzor_s]=param2tenz_5(pz(1),pz(2),pz(3),pz(4),pz(5),pz(6));
        S_fit = ToDTISignal(N,g,vekt_grad,Nmol,diff_t,tenzor_s);
        
        if any(isinf(S_fit))
            pst_odhadu(i) = 0;
            S_fit_iter(:,i) =0;
        else
%         pst_odhadu(i) = mvnpdf(S_fit,s,variance); % porovnanie cez funciu MVNPDF
        pst_odhadu(i) = exp(-1/2*((S_fit-s)*variance^(-1)*(S_fit-s)'));
        S_fit_iter(:,i) = S_fit';
        end
    end
  
    podhadu_tenz(1,(j-1)*Nguess+1:j*Nguess) = pst_odhadu;
    S_fit_hist(:,(j-1)*Nguess+1:j*Nguess) = S_fit_iter;
    parametre_hist(:,(j-1)*Nguess+2:j*Nguess+1) = parametre_iter;
    Spst = sum(podhadu_tenz);
    parametre = (1-VZ).*parametre + VZ.*(sum(parametre_hist(:,2:end)'.*( podhadu_tenz'*ones(1,6) ))./Spst) ;
    
    for row=1:Nparam
        for col=1:row,
            CovM(row,col) = sum(((parametre_hist(row,I)-parametre(row))) .* ((parametre_hist(col,I)-parametre(col))) .* podhadu_tenz(I)) / Spst;
            if row~=col,
             CovM(col,row) = CovM(row,col);
            end
        end
    end
    
    for row = 1:6
        for col = 1:6
            CorM(row,col) = CovM(row,col)./(sqrt(CovM(row,row)).*sqrt(CovM(col,col)));
        end
    end

    [V,D] = eig(CorM);                        % CovM*V = V*D, i.e. D = V' * CovM * V
    [sigma2e,IX] = sort(diag(D),'descend');   % sort eigenvalues from the highest to the lowest
%     sigmae_ZS = sqrt(max(sigma2e,0))';
    sigmae_ZS = sqrt(sigma2e)';
    maxsigma = max(sigmae_ZS);
    sigmae_ZS(sigmae_ZS<fAntiDimCollapse*maxsigma) = fAntiDimCollapse*maxsigma; % protect against dimension collapse
    V = V(:,IX);
%     ds = diag(sigmae)*V';
    sigmae_new = sigmae_ZS*V'.*sigmae;
    sigmae = (1-VS).*sigmae+VS.*sigmae_new;
%     disp(parametre)
    waitbar(j/Nupdates);
    disp(['Parametre: ',num2str(parametre),'  SD: ',num2str(sigmae)]);

end
close(h)
toc;

%%
[tenzor_P]=param2tenz_5(zadane_P(1),zadane_P(2),zadane_P(3),zadane_P(4),zadane_P(5),zadane_P(6));
 S_fit_Za = ToDTISignal(N,g,vekt_grad,Nmol,diff_t,tenzor_P);

[tenzor_MC]=param2tenz_5(parametre(1),parametre(2),parametre(3),parametre(4),parametre(5),parametre(6));
 S_fit_MC = ToDTISignal(N,g,vekt_grad,Nmol,diff_t,tenzor_MC);

[tenzor_EST]=param2tenz_5(parametre_EST(1),parametre_EST(2),parametre_EST(3),parametre_EST(4),parametre_EST(5),parametre_EST(6));
 S_fit_EST = ToDTISignal(N,g,vekt_grad,Nmol,diff_t,tenzor_EST);
 
 
figure()
hold on
% plot(S_fit_Za','g');
plot(S_fit_MC','r');
plot(S_fit_EST,'m');
plot(s,'b')
legend('Signal z pristupu Monte Carlo','Signal zo stanoveneho tenzoru','Namerany signal v simulacii')

% figure()
% plot(sigmae);
        
        
        
        
        
        
        
        

