function [tenzor]=param2tenz_5(ADC,FA,alfa,psi,Pvv,gama)
% funckia vytvara za zadanych parametrov tenzor
% uhly sa zadavaju so znamienkami plus minus
% znamienko minus znamena rotaciu v smere hod. ruciciek
% znamienko plus znamena rotaciu proti smeru hod. ruciciek

%% vypocet eigenvalues
A = ADC;
x = Pvv;
F = FA;

M = (1-F^2);
XXX = (-(A+A*x)+sqrt( (A+A*x)^2+4*(x-M-M*x^2)*(M*A^2) ) )/(2*(x-M-M*x^2));

D1_s = ADC;
D2_s = XXX;
D3_s = Pvv*D2_s;

D_s = diag([D1_s D2_s D3_s]);

%% vypocet eigenvectors
vek = [1 0 0; 0 0 1 ; 0 1 0];
V_s = zeros(3);
% anticlockwise
Rot_X_ac = [1 0 0; 0 cos(-1*(gama)) -sin(-1*(gama)); 0 sin(-1*(gama)) cos(-1*(gama))];
Rot_Y_ac = [cos(-1*(psi)) 0 sin(-1*(psi));0 1 0 ; -sin(-1*(psi)) 0 cos(-1*(psi))];
Rot_Z_ac = [cos(-1*(alfa)) -sin(-1*(alfa)) 0; sin(-1*(alfa)) cos(-1*(alfa)) 0; 0 0 1];
% clockwise
Rot_X_c = [1 0 0; 0 cos((gama)) sin((gama)); 0 -sin((gama)) cos((gama))];
Rot_Y_c = [cos((psi)) 0 -sin((psi));0 1 0 ; sin((psi)) 0 cos((psi))];
Rot_Z_c = [cos((alfa)) sin((alfa)) 0; -sin((alfa)) cos((alfa)) 0; 0 0 1]; 

if gama>0; RotX = Rot_X_c;
else RotX = Rot_X_ac; end

if psi>0; RotY = Rot_Y_c;   
else RotY = Rot_Y_ac; end  

if alfa>0; RotZ = Rot_Z_c; 
else RotZ = Rot_Z_ac; end  

for i = 1:3 ; V_s(:,i) = RotZ * (RotY * (RotX * vek(:,i))); end

%% vypocet tenzora
tenzor = V_s * D_s * V_s';