function [ADC,FA,alfa,psi,Pvv,gama]=tenz2param_3(tenzor)
% uhly vo funckii nadobudavaju plusove a minusove hodnoty
% znamienko minus pred uhlom znamen8, 6e sa jedno o otazcanie v smere
% hodinov7ch ruciciek
% nameienko plus zanmena otacanie proti smeru hodinovych ruciciek


%% Stanovenie eigenvalues a eigenvectors
if any(any(isnan(tenzor))) || any(any(isinf(tenzor)))
ADC = nan; FA = nan; alfa = nan; psi = nan; Pvv = nan; gama = nan;
else
[V,D] = eig(tenzor);            % vypocet eigenvalues a eigenvector

% zoradenie eigenvalues
[a,I]=sort(diag(D),'descend');  % detekcia indexov
V = V(:,I);                     % preskupenie eigenvectors
d = [D(1) D(5) D(9)];           % pomocny vektor s eigenvalues
D = diag(d(I));                 % preskupenie eigenvalues podla velkosti, do jednotkovej matice

% vekt3d(16,V(:,1),'r',[]);
%% stanovenie skalarnych parametrov
% Parameter ADC - apparent diffusion coefcient (v hlavnej poloosi difuzneho elipsoidu)
ADC = D(1);                     % predstavujeho najvacsia eigenvalues hodnota

% FA - univerzalny postup pre obe varianty
FA = sqrt(1/2).*(sqrt( (D(1)-D(5)).^2 + (D(5)-D(9)).^2 + (D(9)-D(1)).^2 )./ sqrt( D(1).^2+D(5).^2+D(9).^2 ));
Pvv = D(9)/D(5);                % Pvv <0,1> pomer medzi dvoma vedlajsimi poloosi difuzneho elipsoidu

%% stanovenie uhlov
% parameters polar,azimut,gama  
% polar - uhol zdvihu od roviny XY resp. medzi hlavnou vektorom
% elipsoidu a jeho priemetom do tejto roviny (suradnica v smere osi Z je
% nulova) azimut - uhol medzi priemetom hlavneho vektoru elipsoidu do
% roviny XY a kladnou xovou poloosou


avek=V(:,1);            % vychadzame z hlavnej poloosi elipsoidu - najdlhsi eigenvector
if avek(1)<0
   avek = -1.*avek; 
end
pvek=avek;              % zbytocny krok, prepis premennej
pvek(3)=0;              % nulovanie Z-ovej suradnice = premietnutie vektora do roviny XY
pvek = pvek/norm(pvek); % normovanie premietnuteho vektora na jednotkovu dlzku

% detekcia uhlov 
psi = acos(sum(avek.*pvek)/(sqrt(sum(avek.^2))*sqrt(sum(pvek.^2))));     % polarny uhol medzi hlavnou poloosou a jej priemetom do roviny XY
alfa = acos(sum([1 0 0]'.*pvek)/(sqrt(sum([1 0 0]'.^2))*sqrt(sum(pvek.^2))));   % azimut medzi hlavnou poloosou a kladnou Xovou poloosou
% rotacne matice pre zrotovanie elipsoidu do "zakladnej pozicie"
Rot_Y_c = [cos(psi) 0 -sin(psi);0 1 0 ; sin(psi) 0 cos(psi)];
Rot_Z_c = [cos(alfa) sin(alfa) 0; -sin(alfa) cos(alfa) 0; 0 0 1];

Rot_Y_ac = [cos(psi) 0 sin(psi);0 1 0 ; -sin(psi) 0 cos(psi)];
Rot_Z_ac = [cos(alfa) -sin(alfa) 0; sin(alfa) cos(alfa) 0; 0 0 1];

if avek(2)<0; RotZ = Rot_Z_ac; else RotZ = Rot_Z_c; end %  alfa = -alfa;
if avek(3)<0; RotY = Rot_Y_c; else RotY = Rot_Y_ac; end %  psi = -psi;
if avek(2)>0; alfa = -alfa; end
if avek(3)<0; psi = -psi; end


sy = RotY * (RotZ * V(:,2));
avek = sy;
pvek = [0 0 1]';
gama = acos(sum(avek.*pvek)/(sqrt(sum(avek.^2))*sqrt(sum(pvek.^2))));

if avek(2)<0; gama = -gama; end

end



















